Attribute VB_Name = "RenameProdParameter_v1"
Sub CATMain()

'**********************************Deklaration Variablen**********************************
    Dim oFenster As Windows
    Dim oDoc As Document
    Dim ObjType As String
    Dim oSel As Selection
    Dim i As Integer
    Dim Box As String
    Dim myParameter As Parameter
    Dim myInputBoxValue As String
    Dim FoundParameterCount As Integer
    Dim RenamedParameterCount As Integer
    Dim StayedParameterCount As Integer
    
'**********************************Nullsetzen der Counter**********************************
    FoundParameterCount = 0
    RenamedParameterCount = 0
    StayedParameterCount = 0

'**********************************Abfrage Dokumente**********************************
    'Zugriff auf alle geffneten CATIA Fenster
    Set oFenster = CATIA.Windows
    'Wenn kein Fenster in der Collection ist, ist kein Dokument geffnet => Makro wird abgebrochen
    If oFenster.Count = 0 Then
        Box = MsgBox("Es ist kein Dokument geladen!" + Chr(10) + "Das Makro kann nicht ausgefhrt werden und wird beendet!", vbCritical, "Keine Dokument geladen")
        Exit Sub
    End If
    'Aktives Dokument holen
    Set oDoc = CATIA.ActiveDocument
    'Objekttyp des aktiven Dokuments abfragen und in Variable bergeben
    ObjType = TypeName(oDoc)
    'Hier wird der Dateityp verglichen. Handelt sich das aktive Dokument nicht um ein Produkt wird das Makro beendet
    If ObjType <> "ProductDocument" Then
        Box = MsgBox("Das aktive Dokument ist kein PartDocumentCATPart!" + Chr(10) + "Das Makro kann nicht ausgefhrt werden!", _
                vbCritical + vbOKOnly, "Falscher Dateityp")
        Exit Sub
    End If
    ObjType = ""
    
'**********************************Suche starten**********************************
    'Erst mal muss das Suchobjekt erstellt werden
    Set oSel = oDoc.Selection
    'Jetzt kann die Selektion geleert werden falls eine Pre-Selektion vorlag
    oSel.Clear
    'Jetzt wird gesucht und das Ergebniss der Suche in die Such-Collection bergeben
    oSel.Search "CATKnowledgeSearch.InternalParameter,all"
    
'**********************************Schleife durch Such-Collection**********************************
    'Erst mal eine Abfrage ob sich berhaupt Parameter in der Such-Collection befinden
    If oSel.Count = 0 Then
        Box = MsgBox("Es wurden keine Parameter gefunden" + Chr(10) + "Das Makro wird beendet", vbInformation, "Makro beendet")
        Exit Sub
    End If
    
    'Schleife durch alle Selektierten Parameter
    For i = 1 To oSel.Count
        'Hier wird dem Objekt "myParameter" der aktuelle Parameter aus der Selektion zugewiesen
        Set myParameter = oSel.Item(i).Value
        'Abfrage welche Parameter umbenannt werden sollen. In diesem Beispiel alle die Test heien
        If myParameter.Name = "Test" Then
            'Zhler der gefundenen Parameter die das Kriterium erfllen erhhen
            FoundParameterCount = FoundParameterCount + 1
            'Hier erscheint die InputBox und der Anwender muss einen Wert eingeben
            myInputBoxValue = InputBox("Bitte geben Sie den neuen Namen ein", "Neuer Name fr den Parameter: " & myParameter.Name, "")
            'Gibt er keinen Wert ein und drckt OK oder drckt er CANCEL wird eine Box angezeigt und der Name bleibt gleich
            If myInputBoxValue <> "" Then
                myParameter.Rename myInputBoxValue
                'Zhler der umbenannten Parameter ehhen
                RenamedParameterCount = RenamedParameterCount + 1
            Else
                Box = MsgBox("Der aktuelle Parameter wurde bersprungen", vbInformation, "Parameter umbenennen")
                'Zhler der nicht umbenannten Parameter ehhen
                StayedParameterCount = StayedParameterCount + 1
            End If
        End If
    Next
    
'**********************************Selektion aufheben**********************************
    'Hebt die Selektion wieder auf
    oSel.Clear
    
'**********************************Ausgabe fr den Anwender**********************************
    'Das ganze wird hier ber eine Funktion gelst
    CreateTheMessage FoundParameterCount, RenamedParameterCount, StayedParameterCount
    

End Sub

'>>>>>>>>>>>>>>>>>>>>>>>>>Funktion fr Anwenderausgabe<<<<<<<<<<<<<<<<<<<<<<<<<<<
Private Function CreateTheMessage(ByRef FoundParameterCount As Integer, ByRef RenamedParameterCount As Integer, ByRef StayedParameterCount As Integer)

'**********************************Deklarationen**********************************
    Dim M1 As String
    Dim M2 As String
    Dim M3 As String
    Dim M4 As String
    Dim Skin
    Dim Title As String
    Dim Box As String

'**********************************Variablen mit Werten fllen**********************************
    M1 = "Das Makro wurde erfolgreich beendet"
    
    'Fallunterscheidung zwischen den Parameter
    If FoundParameterCount = 1 Then
        M2 = "Es wurde " & FoundParameterCount & " Parameter im Dokument gefunden der die Kriterien erfllt"
    Else
        M2 = "Es wurden " & FoundParameterCount & " Parameter im Dokument gefunden die die Kriterien erfllen"
    End If
    
    If RenamedParameterCount = 1 Then
        M3 = "Davon wurde " & RenamedParameterCount & " Parameter umbenannt"
    Else
        M3 = "Davon wurden " & RenamedParameterCount & " Parameter umbenannt"
    End If
    
    If StayedParameterCount = 1 Then
        M4 = StayedParameterCount & " Parameter wurde nicht umbenannt"
    Else
        M4a = StayedParameterCount & " Parameter wurden nicht umbenannt"
    End If

    Skin = vbInformation
    Title = "Makro erfolgreich beendet"

'**********************************Ausgabe der MsgBox**********************************

    Box = MsgBox(M1 + Chr(10) + Chr(10) + M2 + Chr(10) + M3 + Chr(10) + M4, Skin, Title)
    
End Function

